src/apiclient/urls.py
from django.urls import path
from . import views


urlpatterns = [
    path('oauth/', views.oauth, name='apiclient_oauth'),
    path('auth_callback/', views.oauth_callback, name='apiclient_oauth_callback'),
    path('oauth2/', views.oauth2, name='apiclient_oauth2'),
    path('oauth2_redirect/', views.oauth2_redirect, name='apiclient_oauth2_redirect'),
]

src/archive/urls.py
from django.urls import path
from django.views.generic import RedirectView
from . import views

urlpatterns = [
    path("", views.AudiobookList.as_view(), name="list_managed"),
    path('new/', views.list_new, name="list_new"),
    path('new/<path:filename>/', views.file_new, name="file_new"),
    path('move_to_archive/<path:filename>/', views.move_to_archive, name="move_to_archive"),
    path('publishing/', views.list_publishing, name="list_publishing"),
    path('book/<slug:slug>/', views.BookView.as_view(), name="book"),
    path('book/<slug:slug>.json', views.book_json, name="book_json"),
    path('book-youtube-volume/<int:aid>/', views.book_youtube_volume, name="book_youtube_volume"),
    path('file/<int:id>/', views.file_managed, name="file"),
    path('publish/<int:aid>/', views.publish, name="publish"),
    path('convert/<int:aid>/', views.publish, {'publish': False}, name="convert"),
    path('download/<int:aid>/', views.download, name="download"),
    path('download/<int:aid>.<slug:which>', views.download, name="download"),
    path('cancel/<int:aid>/', views.cancel_publishing, name="cancel_publishing"),
    path('remove_to_archive/<int:aid>/', views.remove_to_archive, name="remove_to_archive"),
    path('unmanaged/', views.list_unmanaged, name="list_unmanaged"),
    path('unmanaged/<path:filename>/', views.file_unmanaged, name="file_unmanaged"),
    path('move_to_new/<path:filename>/', views.move_to_new, name="move_to_new"),
]

src/audiobooks/urls.py
from django.contrib import admin
from django.urls import include, path
from django.views.generic import RedirectView
from django.contrib import admin
import django_cas_ng.views


urlpatterns = [
    path('', RedirectView.as_view(url='archive/', permanent=False)),
    path('archive/', include('archive.urls')),
    path('youtube/', include('youtube.urls')),
    path('publish/', include('apiclient.urls')),

    path('admin/', admin.site.urls),
    path('accounts/login/', django_cas_ng.views.LoginView.as_view(), name='cas_ng_login'),
    path('accounts/logout/', django_cas_ng.views.LogoutView.as_view(), name='cas_ng_logout'),
]

src/archive/models.py
import io
import json
from os import unlink
import os.path
from urllib.parse import urljoin

from django.db import models
from time import sleep
from django.contrib.sites.models import Site
from django.utils.functional import cached_property
from django.utils.timezone import now
from django.utils.translation import gettext_lazy as _
from django_pglocks import advisory_lock
import requests
from archive.constants import status
from archive.settings import FILES_SAVE_PATH, ADVERT, ORGANIZATION, PROJECT
from archive.utils import OverwriteStorage, sha1_file
from youtube.utils import concat_audio, standardize_audio


class License(models.Model):
    uri = models.CharField(max_length=255, unique=True)
    name = models.CharField(max_length=255)

    def __str__(self):
        return self.name


class Project(models.Model):
    """ an audiobook project, needed for specyfing sponsors """

    name = models.CharField(max_length=128, unique=True, db_index=True, verbose_name="Nazwa")
    sponsors = models.TextField(blank=True, null=True, verbose_name="Sponsorzy")
    description = models.TextField(blank=True, verbose_name="Opis")
    private_notes = models.TextField(blank=True, verbose_name="Prywatne notatki")
    config = models.ForeignKey('Config', models.PROTECT)
    can_sell = models.BooleanField(default=True, verbose_name="Do sprzedaży")
    required_license = models.ForeignKey('License', models.PROTECT, blank=True, null=True, verbose_name='Wymagana licencja')
    youtube = models.ForeignKey('youtube.YouTube', models.PROTECT)
    icon = models.FileField(upload_to='archive/project', blank=True, null=True)
    info_flac = models.FileField(upload_to='archive/info_flac', blank=True)

    class Meta:
        verbose_name = _("project")
        verbose_name_plural = _("projects")
        ordering = ("name",)

    def __str__(self):
        return self.name

    def get_description(self):
        if self.description:
            return self.description
        return "Audiobook nagrany w ramach projektu %s%s." % (
            self.name,
            " finansowanego przez %s" % self.sponsors if self.sponsors else "",
        )

    def get_icon_url(self):
        if not self.icon:
            return ''
        return urljoin(
            'https://' + Site.objects.get_current().domain,
            self.icon.url
        )


class Config(models.Model):
    name = models.CharField(max_length=255)
    intro_flac = models.FileField(upload_to='config/intro_flac', blank=True)
    intro_min_seconds = models.IntegerField()
    outro_flac = models.FileField(upload_to='config/outro_flac', blank=True)
    outro_min_seconds = models.IntegerField()

    class Meta:
        verbose_name = _("Configuration")
        verbose_name_plural = _("Configurations")

    def __str__(self):
        return self.name

    def prepare_audio(self, audiobook):
        total_duration = audiobook.total_duration
        files = []
        if self.intro_flac and total_duration > self.intro_min_seconds and audiobook.is_first:
            files.append(standardize_audio(self.intro_flac.path))
        files.append(standardize_audio(audiobook.source_file.path))
        if self.outro_flac and total_duration > self.outro_min_seconds and audiobook.is_last:
            files.append(standardize_audio(self.outro_flac.path))
        output = concat_audio(files)
        for d in files:
            unlink(d)
        return output


def source_upload_to(intance, filename):
    return os.path.join(FILES_SAVE_PATH, filename) # FIXME: what about really long file names?


class Audiobook(models.Model):
    source_file = models.FileField(upload_to=source_upload_to, max_length=255, 
            verbose_name=_('source file'), editable=False)
    source_sha1 = models.CharField(max_length=40, editable=False)
    duration = models.FloatField(null=True, editable=False)

    title = models.CharField(max_length=255, verbose_name=_('title'))
    part_name = models.CharField(max_length=255, verbose_name=_('part name'), help_text=_('eg. chapter in a novel'),
                                 default='', blank=True)
    index = models.IntegerField(verbose_name=_('index'), default=0, help_text=_('Ordering of parts of a book.'))
    youtube_volume = models.CharField(
        _("Volume name for YouTube"),
        max_length=100,
        blank=True,
        help_text=_(
            "If set, audiobooks with the save value will be published as single YouTube video."
        ),
    )
    artist = models.CharField(max_length=255, verbose_name=_('artist'))
    conductor = models.CharField(max_length=255, verbose_name=_('conductor'))
    encoded_by = models.CharField(max_length=255, verbose_name=_('encoded by'))
    date = models.CharField(max_length=255, verbose_name=_('date'))
    project = models.ForeignKey(Project, models.PROTECT, verbose_name=_('project'))
    slug = models.SlugField(max_length=120, blank=True, help_text=_('WL catalogue slug of the book.'))
    translator = models.CharField(max_length=255, null=True, blank=True, verbose_name=_('translator'))
    modified = models.DateTimeField(null=True, editable=False)
    license = models.ForeignKey(License, models.PROTECT, null=True, blank=True, verbose_name=_('license'))
    license_secondary = models.ForeignKey(License, models.PROTECT, null=True, blank=True, verbose_name=_('secondary license'), related_name='secondary')

    # publishing process
    mp3_status = models.SmallIntegerField(null=True, editable=False, choices=status.choices)
    mp3_file = models.FileField(null=True, upload_to='archive/final', storage=OverwriteStorage(), editable=False)
    mp3_published = models.DateTimeField(null=True, editable=False)

    ogg_status = models.SmallIntegerField(null=True, editable=False, choices=status.choices)
    ogg_file = models.FileField(null=True, upload_to='archive/final', storage=OverwriteStorage(), editable=False)
    ogg_published = models.DateTimeField(null=True, editable=False)

    youtube_status = models.SmallIntegerField(null=True, editable=False, choices=status.choices)
    youtube_published = models.DateTimeField(null=True, editable=False)
    youtube_id = models.CharField(max_length=255, blank=True, default='')
    youtube_queued = models.DateTimeField(null=True, blank=True)

    class Meta:
        verbose_name = _("audiobook")
        verbose_name_plural = _("audiobooks")
        ordering = ("title",)

    def __str__(self):
        return self.title

    @property
    def url(self):
        return f'https://wolnelektury.pl/katalog/lektura/{self.slug}/'

    @property
    def parts_count(self):
        return type(self).objects.filter(slug=self.slug).count()

    @property
    def total_duration(self):
        return type(self).objects.filter(slug=self.slug).aggregate(s=models.Sum('duration'))['s']

    @property
    def is_first(self):
        return not type(self).objects.filter(slug=self.slug, index__lte=self.index).exclude(pk=self.pk).exists()

    @property
    def is_last(self):
        return not type(self).objects.filter(slug=self.slug, index__gte=self.index).exclude(pk=self.pk).exists()
    
    @property
    def youtube_volume_count(self):
        total = 0
        prev_volume = None
        for a in type(self).objects.filter(slug=self.slug).order_by("index"):
            if not a.youtube_volume or a.youtube_volume != prev_volume:
                total += 1
            prev_volume = a.youtube_volume
        return total

    @property
    def youtube_volume_index(self):
        index = 0
        prev_volume = None
        for a in type(self).objects.filter(slug=self.slug, index__lte=self.index).order_by("index"):
            if not a.youtube_volume or a.youtube_volume != prev_volume:
                index += 1
            prev_volume = a.youtube_volume
        return index

    @property
    def is_youtube_publishable(self):
        return (
            not self.youtube_volume
            or not type(self)
            .objects.filter(slug=self.slug, youtube_volume=self.youtube_volume, index__lt=self.index)
            .exists()
        )

    def youtube_publish(self):
        if not self.is_youtube_publishable:
            return False
        self.youtube_status = status.QUEUED
        self.youtube_queued = now()
        self.save(update_fields=['youtube_status', 'youtube_queued'])

    def published(self):
        return self.mp3_published and self.ogg_published

    def publish(self, user, publish=True):
        from . import tasks
        self.mp3_status = self.ogg_status = status.WAITING
        self.save(update_fields=['mp3_status', 'ogg_status'])
        tasks.Mp3Task.delay(user.id, self.pk, publish=publish).task_id
        tasks.OggTask.delay(user.id, self.pk, publish=publish).task_id

    def get_source_sha1(self):
        assert self.pk or self.source_sha1
        if not self.source_sha1:
            with advisory_lock(f'get_source_sha1_{self.pk}'):
                with open(self.source_file.path, 'rb') as f:
                    self.source_sha1 = sha1_file(f)
                self.save(update_fields=['source_sha1'])
        return self.source_sha1

    def new_publish_tags(self):
        title = self.title
        if self.translator:
            title += ' (tłum. %s)' % self.translator

        copyright = "%s %s." % (
                self.date, ORGANIZATION)
        if self.license:
            copyright += " Licensed to the public under %s verify at %s" % (
                self.license.uri, self.url)

        comment = "\n".join((
            self.project.get_description(),
            ADVERT
        ))

        tags = {
            'album': PROJECT,
            'albumartist': ORGANIZATION,
            'artist': self.artist,
            'comment': comment,
            'conductor': self.conductor,
            'contact': self.url,
            'copyright': copyright,
            'date': self.date,
            'genre': 'Speech',
            'language': 'pol',
            'organization': ORGANIZATION,

src/archive/forms.py
from datetime import datetime
import os
import os.path

from django import forms
from django.utils.translation import gettext_lazy as _
import mutagen
from django.utils.encoding import force_bytes

from youtube.utils import get_duration
from archive.models import Audiobook
from archive.settings import FILES_PATH, NEW_PATH
from archive.utils import ExistingFile, sha1_file

class AudiobookForm(forms.ModelForm):
    class Meta:
        model = Audiobook
        exclude = [
            'youtube_id', 'youtube_queued'
        ]

    def save(self, commit=True, path=None):
        """ Performs normal save, with given file as an source audiobook.

            `path' is relative to NEW_PATH.
        """
        m = super(AudiobookForm, self).save(commit=False)
        m.modified = datetime.now()

        if path:
            # adding a new audiobook
            if not os.path.isdir(FILES_PATH):
                os.makedirs(FILES_PATH)
            # save the file in model

            abs_path = os.path.join(NEW_PATH, path)
            m.duration = get_duration(abs_path)
            m.source_file.save(
                path,
                ExistingFile(abs_path))

#            f = open(force_bytes(m.source_file.path))
#            m.source_sha1 = sha1_file(f)
#            f.close()

        if commit:
            m.save()

src/archive/templates/archive/audiobook_list.html
{% extends "archive/list.html" %}
{% load i18n %}
{% load pagination_tags %}
{% load tags %}


{% block menu-active-audiobooks %}active{% endblock %}


{% block file-list-title %}
  {% trans "Audiobooks" %}
{% endblock %}


{% block file-list-info %}
  <form>
    <div class="input-group">
      <input class="form-control" name="s" value="{{ request.GET.s }}">
      <div class="input-group-append">
	<button class="btn btn-primary">Szukaj</button>
      </div>
    </div>
  </form>
{% endblock %}

{% block file-list-wrapper %}
  {% autopaginate object_list 50 %}
  {{ block.super }}
  {% paginate %}
{% endblock %}


{% block file-list %}
  <thead>
    <tr>
      <th>Slug</th>
      <th>{% trans "Title" %}</th>
      <th>{% trans "YouTube volume" %}</th>
      <th>MP3</th>
      <th>Ogg</th>
      <th>YouTube</th>
    </tr>
  </thead>
  {% for audiobook in object_list %}
    <tr>
      <td>
        {% if audiobook.slug %}
          <a href="{% url "book" audiobook.slug %}">{{ audiobook.slug }}</a>
        {% endif %}
        <td>
          <a href='{% url "file" audiobook.id %}'>{{ audiobook }}</a>
        </td>
        <td>
          {{ audiobook.youtube_volume }}
        </td>
        <td>
          {% status audiobook "mp3" %}
        </td>
        <td>
          {% status audiobook "ogg" %}
        </td>
        <td>
          {% status audiobook "youtube" %}
        </td>
    </tr>
  {% endfor %}
{% endblock %}

src/archive/templates/archive/base.html
{% extends "base.html" %}
{% load i18n %}

{% block repo-zones-nav %}
  <ul class="nav nav-pills">
    <li class="nav-item"><a class="nav-link {% block menu-active-audiobooks %}{% endblock %}" href="{% url "list_managed" %}">{% trans "Audiobooks" %}</a></li>
    <li class="nav-item"><a class="nav-link {% block menu-active-publishing %}{% endblock %}" href="{% url 'list_publishing' %}">{% trans "Publishing" %}</a></li>
    <li class="nav-item"><a class="nav-link {% block menu-active-new %}{% endblock %}" href="{% url 'list_new' %}">{% trans "New" %}</a></li>
    <li class="nav-item"><a class="nav-link {% block menu-active-unmanaged %}{% endblock %}" href="{% url 'list_unmanaged' %}">{% trans "Archive" %}</a></li>
  </ul>

  <ul class="nav">
    {% if user.is_staff %}
      <li class="nav-item"><a class="nav-link" href='{% url "admin:archive_project_changelist" %}'>{% trans "Projects" %}</a></li>
    {% endif %}
    {% if user.is_authenticated %}
      <li class="nav-item"><a class="nav-link" href="{% url 'cas_ng_logout' %}">{% trans "Logout" %}</a></li>
    {% else %}
      <li class="nav-item"><a class="nav-link" href="{% url 'cas_ng_login' %}">{% trans "Login" %}</a></li>
    {% endif %}
    {% if user.is_staff %}
      <li class="nav-item"><a class="nav-link" href='{% url "admin:index" %}'>{% trans "Administration" %}</a></li>
    {% endif %}
    {% if user.is_authenticated %}
      <li class="nav-item navbar-text">{{ user }}</li>
    {% endif %}
</ul>
{% endblock %}

src/archive/templates/archive/book.html
{% extends "archive/base.html" %}
{% load i18n %}
{% load tags %}


{% block menu-active-audiobooks %}active{% endblock %}


{% block content %}
  <div class="card mt-4">
    <div class="card-header">
      <h2>{{ object_list.0.book.title }}</h2>
    </div>
    <div class="card-body">
      <table class="table">
        <thead>
          <tr>
            <th>{% trans "Index" %}</th>
            <th>{% trans "Title" %}</th>
            <th>MP3</th>
            <th>Ogg</th>
            <th colspan="5">YouTube</th>
          </tr>
        </thead>
        <tbody>
          {% with volumes=object_list.0.youtube_volume_count %}
            {% for audiobook in object_list %}
              <tr>
                <td>{{ audiobook.index }}</td>
                <td>
                  <a href="{% url 'file' audiobook.id %}">
                    {% if audiobook.part_name %}
                      {{ audiobook.part_name }}
                    {% else %}
                      <em class="text-warning" title="ddd">
                        ({{ audiobook }})
                      </em>
                    {% endif %}
                  </a>
                </td>
                <td>{% status audiobook "mp3" %}</td>
                <td>{% status audiobook "ogg" %}</td>
                {% ifchanged audiobook.youtube_volume_index %}
                  <td>
                    {{ audiobook.youtube_volume_index }}/{{ volumes }}
                  </td>
                  <td>
                    <form method="POST" action="{% url 'book_youtube_volume' audiobook.id %}">
                      {% csrf_token %}
                      <input name='volume' value="{{ audiobook.youtube_volume }}" class="form-control">
                    </form>
                  </td>
                  <td>
                    {% if audiobook.youtube_volume %}
                      {{ audiobook.total|duration }}
                    {% else %}
                      <small class="text-secondary">{{ audiobook.subtotal|duration }}</small>
                    {% endif %}
                  </td>
                  <td>
                    {{ audiobook.duration|duration }}
                  </td>
                  <td>
                    {% status audiobook "youtube" %}
                  </td>
                {% else  %}
                  <td>
                    –
                  </td>
                  <td>
                    <span class="text-secondary">
                      <form method="POST" action="{% url 'book_youtube_volume' audiobook.id %}">
                        {% csrf_token %}
                        <input name='volume' value="{{ audiobook.youtube_volume }}" class="form-control">
                      </form>
                    </span>
                  </td>
                  <td>
                    <small class="text-secondary">{{ audiobook.subtotal|duration }}</small>
                  </td>
                  <td class="text-secondary">
                    {{ audiobook.duration|duration }}
                  </td>
                  <td>
                  </td>
                {% endifchanged %}
              </tr>
            {% endfor %}
          {% endwith %}
        </tbody>
      </table>
      <form method="post" action="{% url 'youtube_book_publish' view.kwargs.slug %}">
        {% csrf_token %}
        <button class="btn btn-primary">
          Opublikuj wszystko na YouTube
        </button>
      </form>
    </div>
{% endblock %}

src/archive/templates/archive/file_managed.html
{% extends "archive/base.html" %}
{% load i18n %}
{% load tags %}
{% load bootstrap4 %}


{% block menu-active-audiobooks %}active{% endblock %}


{% block content %}


{% for alert in alerts %}
  <div class="mt-4 alert alert-warning">{{ alert }}</div>
{% endfor %}



<div class="row mt-4">
  <div class="col-xl-12">
    <div class="card mt-4">
      <div class="card-header">
        <h2>{% if audiobook.slug %}<a href="{% url 'book' audiobook.slug %}" %}">{% endif %}{{ audiobook.title }}{% if audiobook.slug %}</a>{% endif %}</h2>
      </div>
      <div class="card-body">
        <form method='post' action='.'>
          {% csrf_token %}
	  {% bootstrap_form form layout="horizontal" %}
          <input class="btn btn-primary" type="submit" value='{% trans "Commit" %}' />
        </form>
      </div>
    </div>
  </div>


</div>








<div class="row">


  <div class="col-xl-8">


    <div class="card mt-4">
      <div class="card-header">
        <h3>MP3, Ogg</h3>
      </div>
      <div class="card-body">
        {% if audiobook.mp3_status or audiobook.ogg_status or audiobook.youtube_status %}
          <h2>{% trans "Publishing pending" %}</h2>
          <form method="post" action="{% url 'cancel_publishing' audiobook.id %}">
            {% csrf_token %}
            <input class='btn btn-danger' type="submit" value="{% trans "Cancel publishing" %}" />
          </form>
        {% endif %}


        {% if audiobook.mp3_status %}
          <hr/>
          <h2>MP3</h2>

          <p>Status: <b>{{ audiobook.get_mp3_status_display }}</b></p>
        {% endif %}

        {% if audiobook.ogg_status %}
          <hr/>
          <h2>Ogg Vorbis</h2>

          <p>Status: <b>{{ audiobook.get_ogg_status_display }}</b></p>
        {% endif %}


        {% if audiobook.mp3_file %}
          <p><a href="{% url 'download' audiobook.id 'mp3' %}">{% trans "Download MP3 file." %}</a></p>
          {% if audiobook.mp3_published %}
            <p>{% trans "Published:" %} {{ audiobook.mp3_published }}</a></p>
          {% else %}
            <p>{% trans "Not published yet." %}</p>
          {% endif %}
        {% else %}
          <p>{% trans "MP3 file hasn't been generated yet." %}</p>
        {% endif %}

        {% if audiobook.ogg_file %}
          <p><a href="{% url 'download' audiobook.id 'ogg' %}">{% trans "Download Ogg Vorbis file." %}</a></p>
          {% if audiobook.ogg_published %}
            <p>{% trans "Published:" %} {{ audiobook.ogg_published }}</a></p>
          {% else %}
            <p>{% trans "Not published yet." %}</p>
          {% endif %}
        {% else %}
          <p>{% trans "Ogg Vorbis file hasn't been generated yet." %}</p>
        {% endif %}

        {% if user_can_publish %}
          <form method="post" action="{% url 'publish' audiobook.id %}">
            {% csrf_token %}
            <input class="btn btn-primary" type="submit" value="{% trans "Publish" %}" />
          </form>
        {% else %}
          <a class="btn btn-primary" href="{% url 'apiclient_oauth' %}">Podłącz się</a>
        {% endif %}

        {% if not audiobook.mp3_published or not audiobook.ogg_published %}
          <form class="mt-3" method="post" action="{% url 'convert' audiobook.id %}">
            {% csrf_token %}
            <input class="btn btn-secondary" type="submit" value="{% trans "Convert without publishing" %}" />
          </form>
        {% endif %}


      </div>
    </div>



    <div class="card mt-4">
      <div class="card-header">
        <h3>Metadane dla MP3, Ogg</h3>
      </div>
      <div class="card-body">
        <table class='table'>
          tagi, które zostałyby zapisane do pliku, gdyby go teraz opublikować
          {% tags_table audiobook.new_publish_tags 0 %}
        </table>
      </div>
    </div>

  </div>


  <div class="col-xl-4">
    <div class="card mt-4">
      <div class="card-header">
        <h3>
          YouTube
          {% if audiobook.youtube_status %}
            <span class="badge badge-pill badge-primary">{{ audiobook.get_youtube_status_display }}</span>
          {% endif %}
        </h3>
      </div>
      <div class="card-body">
        <img src="{% url 'youtube_thumbnail' audiobook.id %}" style="width:100%">
        <strong>{{ youtube_title }}</strong><br><br>
        {{ youtube_description|linebreaksbr }}



        {% if audiobook.is_youtube_publishable %}
          <br>
          <p>
	    <a href="{% url 'youtube_preview' audiobook.id %}">
              {% trans "Preview YouTube metadata" %}
            </a>
          </p>

        {% endif %}

        {% if audiobook.youtube_id %}
          <form method="post" action="{% url 'youtube_update_thumbnail' audiobook.id %}">
            {% csrf_token %}
            <input class="btn btn-secondary" type="submit" value="{% trans "Update YouTube thumbnail" %}">
          </form>
          <br>

          <form method="post" action="{% url 'youtube_update' audiobook.id %}">
            {% csrf_token %}
            <input class="btn btn-secondary" type="submit" value="{% trans "Update YouTube metadata" %}">
          </form>
        {% endif %}
        <form method="post" action="{% url 'youtube_publish' audiobook.id %}">
          {% csrf_token %}
          <input class="btn btn-primary" type="submit" value="{% trans "Publish on YouTube" %}" />
        </form>

      </div>
      <div class="card-footer">
        {% if audiobook.youtube_id %}
          <p>
            <a href="https://youtu.be/{{ audiobook.youtube_id }}" target="_blank" title="{% trans "See on YouTube" %}">
              <img src="https://i.ytimg.com/vi/{{ audiobook.youtube_id }}/hq720.jpg" style="width: 100%">
            </a>
          </p>
        {% endif %}
        <p>{% trans "Published:" %} {{ audiobook.youtube_published }}</a></p>

      </div>
    </div>
  </div>


</div>





<div class="card mt-4 mb-4">
  <div class="card-header">
    <h2>Plik źródłowy</h2>
    (informacje fizycznie ze źródłowego pliku)
  </div>
  <div class="card-body">

    <div class="row">
      <div class="col-lg-8">

        <p>Last modified: {{ audiobook.modified }}</p>
        <p>Plik źródłowy: <a href='{{ audiobook.source_file.url }}'>{{ path }}</a>
          (sha1: <tt>{{ audiobook.source_sha1 }}</tt>).
        </p>
        {% multiple_tags_table tags %}
      </div>

      <div class="col-xl-4">
        <div class="card">
          <div class="card-body">
            <form method="post" action="{% url 'remove_to_archive' audiobook.id %}"
                  onsubmit='return confirm("{% trans "Are you sure you want to move this audiobook to archive?" %}")'>
              {% csrf_token %}

              <p>
                Jeśli ten plik nie jest potrzebny, możesz usunąć informacje o nim z systemu,
                zachowując go tylko w postaci samego źródłowego pliku.
              </p>

              <input class="btn btn-danger" type="submit" value="{% trans "Remove to archive" %}" />
            </form>
          </div>
        </div>
      </div>
    </div>
  </div>
</div>


{% endblock %}

src/archive/templates/archive/file_new.html
{% extends "archive/base.html" %}
{% load i18n tags bootstrap4 %}


{% block menu-active-new %}active{% endblock %}


{% block content %}

<div class="card mt-4">
  <div class="card-header">
    <h1>{{ filename }}</h1>
  </div>
  <div class="card-body">
    <form method="post" action="{% url 'move_to_archive' filename %}">
      {% csrf_token %}
      <input class="btn btn-danger" type="submit" value="{% trans "Move to archive" %}" />
    </form>

    <hr>

    {% multiple_tags_table tags %}

    <hr>

    <form method='post' action='.'>
      {% csrf_token %}
      {% bootstrap_form form %}
      <input class="btn btn-primary" type="submit" value='{% trans "Commit" %}' />
    </form>
  </div>
</div>


{% endblock %}

src/archive/templates/archive/file_unmanaged.html
{% extends "archive/base.html" %}
{% load i18n %}
{% load tags %}


{% block menu-active-unmanaged %}active{% endblock %}


{% block messages %}
    {% if err_exists %}
        <p>{% trans "File with same name already exists!" %}</p>
    {% endif %}
{% endblock %}


{% block content %}

<div class="card mt-4">
  <div class="card-header">
    <h1>{{ filename }}</h1>
  </div>
  <div class="card-body">
    {% multiple_tags_table tags %}

    <form method="post" action="{% url 'move_to_new' filename %}">
      {% csrf_token %}
      <input class="btn btn-primary" type="submit" value="{% trans "Move to new files" %}" />
    </form>
  </div>
</div>


{% endblock %}